#include "options.h"
	FILE* fpe=0;
int parse_options(char* optfile)
{
	char buff[1024]="";//read buffer
	char *optstring;
	FILE* fp=fopen(OPT_OPTFILE,"r");
	if(optfile)strcpy(OPT_OPTFILE,optfile);
	if(!fp)
	{//error
		//print2log("ERROR: cannot open %s",OPT_OPTFILE);
		return 0;
	}
											if(strlen(OPT_DEBUGFILE))fpe=fopen(OPT_DEBUGFILE,"at");
	while(!feof(fp))
	{//read optfile
		memset(buff,0,sizeof(buff));//zero filling
		fgets(buff,1024,fp);
		if(strlen(buff))
		{//some readed

											if(fpe)fprintf(fpe,"find: %s\n",buff);
			if(strlen(buff) && !(optstring=strchr(buff,' ')))
			{//error
											if(fpe)fprintf(fpe,"ERROR: no option for %s in %s\n",buff,OPT_OPTFILE);
											if(fpe)fclose(fpe);
				fclose(fp);
				return 0;
			}
			*optstring=0;
			optstring++;//next character
			if(optstring[strlen(optstring)-1]=='\n')optstring[strlen(optstring)-1]=0;//end zero
											if(fpe)fprintf(fpe,"optstring: %s\n",optstring);
			if(!strcasecmp(buff,"logfile"))
				strcpy(OPT_LOGFILE,optstring);
			if(!strcasecmp(buff,"pidfile"))
				strcpy(OPT_PIDFILE,optstring);
			if(!strcasecmp(buff,"port"))
				OPT_PORT=atoi(optstring);
			if(!strcasecmp(buff,"allowlist"))
				strcpy(OPT_ALLOWLIST,optstring);
		}
	}
											if(fpe)fprintf(fpe,"options: \nOPT_LOGFILE: %s\nOPT_PIDFILE: %s\nOPT_PORT: %d\nOPT_ALLOWLIST: %s\n",OPT_LOGFILE,OPT_PIDFILE,OPT_PORT,OPT_ALLOWLIST);
											if(fpe)fclose(fpe);
	return 1;
}
struct in_addr allowlist[255];//255 max allows
int load_allow(char *allowlistfile)
{//load allow list file, and fill ip table by it
//if error or empty - return 0
//else return number of allowed ips

	FILE* fp=fopen(allowlistfile,"rt");
	int i=0;//
	char buff[255];
											if(strlen(OPT_DEBUGFILE))fpe=fopen(OPT_DEBUGFILE,"at");
	if(!fp)
	{
											if(fpe)fprintf(fpe,"cannot open file %s: %s",allowlistfile,strerror( errno ));
											if(fpe)fclose(fpe);
		return 0;
	}
											if(fpe)fprintf(fpe,"allowed: \n");
	while(!feof(fp))
	{//read all file
		memset(buff,0,sizeof(buff));
		if(fgets(buff,255,fp))
		{//some readed
			if(buff[strlen(buff)-1]=='\n')buff[strlen(buff)-1]=0;//cr to zero
			inet_aton(buff,&allowlist[i++]);
											if(fpe)fprintf(fpe,"%d: %s\n",i,inet_ntoa(allowlist[i-1]));

		}
	}
											if(fpe)fclose(fpe);
	return i;
}
int check_allow(char* ip)
{//check ip for a allowance
//return position in list
//or -1 if access denied
	int i=0;//index
	while(allowlist[i].s_addr)
	{//check all list
		if(!strcmp(inet_ntoa(allowlist[i]),ip))return i;//we found!
		i++;//next element
	}
	return -1;//not found
}
